#include "search.h"

#define ASTERISK -2000

#ifndef WINDOWS
int main(int argc, char* argv[])
{
  int i = 1;
  int relative = 0, print = 0, ascii = 0, options = 0;
  FILE *source;
  l_num numbers;
  
  if(argc < 2)
  {
     printf("Usage: %s [-rpa] file(s)\n", argv[0]);
     printf(" -r:	relative search\n");
     printf(" -p:	print data found (HEX/ASCII)\n");
     printf(" -a:	Do ASCII data read (default HEX)\n");
     exit(0);
  }
  if(argv[1][0] == '-')
  {
	int j; 

	options = 1;
	if(argc < 3)
	{
     		printf("Usage: %s [-r] file(s)\n", argv[0]);
     		printf(" -r:	relative search (default off)\n");
     		printf(" -p:	print data found (HEX/ASCII) (default off)\n");
     		printf(" -a:	Do ASCII data read (default HEX) (default off)\n");
		exit(1);
	}
	for(j = 1; j < strlen(argv[1]); j++)
	{
		switch(argv[1][j])
		{
			case 'r': relative = 1; break;
			case 'p': print = 1; break;
			case 'a': ascii = 1; break;
			default:
				printf("Invalid argument '%c'\n", argv[1][j]);
				exit(1);
		}
	}
  }
  if(options)
	i = 2;
  numbers = Nueva_num();
  if(!ascii)
  {
  	printf("Insert the values separated by spaces (two by two)\nand finish with space and another char(* for any value)\n");
  	numbers = read_num();
  }
  else
  {
  	printf("Type the message and press enter (* for any character)\n");
	numbers = read_ascii();
  }
  if(relative)
	convert_relative(numbers);
  printf("\nSearching...\n");
  for(; i < argc; i++)
  {
  	source = fopen(argv[i], "rb");
  	if(source)
  	{
		if(!relative)
		{
  			if(search(source, numbers, print))
  				printf("File was: %s\n----\n", argv[i]);
		}
		else
		{
  			if(search_relative(source, numbers, print))
  				printf("File was: %s\n----\n", argv[i]);
		}
  		fclose(source);
  	}
  	else
  		printf("Couldn't open file %s\n", argv[i]);
  }
  free_list_num(numbers);
  printf("\n");
  return(0);
}
#endif

int search(FILE* source, l_num numbers, int print)
{
  int buffer, count, found, advanced;
  l_num orig, newstring;

  buffer = 0;
  count = 0;
  found = 0;
  advanced = 0;
  
  if(!numbers)
	return(0);
  orig = numbers;
  newstring = Nueva_num();
  while(buffer != EOF)
  {
     buffer = fgetc(source);
     if(buffer == numbers->data || numbers->data == ASTERISK)
     {
	if(print) newstring = insert_num(buffer, newstring);
        numbers = numbers->next;
	advanced ++;
     }
     else
     {
 	if(advanced)
	{
		fseek(source, ftell(source) - advanced, SEEK_SET);
		count -= advanced;
		advanced = 0;
	}
	if(print) newstring = free_list_num(newstring);
        numbers = orig;
     }
     if(!numbers)
     {
       printf("Found at: %xh", count - num_len(orig) + 1);
       if(print)
       {
	 printf(" -> ");
	 print_num(newstring);
       }
       printf("\n");
       if(print) newstring = free_list_num(newstring);
       advanced = 0;
       numbers = orig;
       found ++;
     }
     count ++;
  }
  return(found);
}

int search_relative(FILE* source, l_num numbers, int print)
{
  int buffer, count, found, advanced, value;
  l_num orig, newstring;

  buffer = 0;
  count = 0;
  found = 0;
  advanced = 0;
  
  if(!numbers)
	return(0);
  orig = numbers;
  newstring = Nueva_num();
  while(buffer != EOF)
  {
     buffer = fgetc(source);
     if(orig == numbers)
	value = buffer;
     if(value+numbers->data == buffer || numbers->data == ASTERISK)
     {
        numbers = numbers->next;
	advanced ++;
        if(print) newstring = insert_num(buffer, newstring);
     }
     else
     {
 	if(advanced)
	{
		fseek(source, ftell(source) - advanced, SEEK_SET);
		count -= advanced;
		advanced = 0;
	}
	if(print) newstring = free_list_num(newstring);
        numbers = orig;
     }
     if(!numbers)
     {
       printf("Found at: %xh", count - num_len(orig) + 1);
       if(print)
       {
	 printf(" -> ");
	 print_num(newstring);
       }
       printf("\n");
       if(print) newstring = free_list_num(newstring);
       numbers = orig;
       found ++;
       advanced = 0;
     }
     count ++;
  }
  return(found);
}


void convert_relative(l_num list)
{
  int data;
  if(list)
	data = list->data;
  while(list)
  {
    if(list->data != ASTERISK)
    	list->data -= data;
    list = list->next;
  }
}




